/*
 * $Id: replay.d,v 1.2 2006/11/23 02:29:43 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
module abagames.ttn.replay;

private import std.stream;
private import abagames.util.sdl.pad;
private import abagames.util.sdl.recordableinput;

/**
 * Save/Load a replay data.
 */
public class ReplayData {
 public:
  static const char[] DIR = "replay";
  static const int VERSION_NUM = 10;
  InputRecord!(PadState) inputRecord;
  long seed;
  int score = 0;
 private:

  public void save(char[] fileName) {
    auto File fd = new File(DIR ~ "/" ~ fileName, FileMode.OutNew);
    fd.write(VERSION_NUM);
    fd.write(seed);
    fd.write(score);
    inputRecord.save(fd);
    fd.close();
  }

  public void load(char[] fileName) {
    auto File fd = new File(DIR ~ "/" ~ fileName, FileMode.In);
    int ver;
    fd.read(ver);
    if (ver != VERSION_NUM)
      throw new Error("Wrong version num");
    fd.read(seed);
    fd.read(score);
    inputRecord = new InputRecord!(PadState);
    inputRecord.load(fd);
    fd.close();
  }
}
